<template>
  <div class="login">
    <div class="login-card">
      <div class="login-banner">
        <!--   主标题     -->
        <h2 class="title">若依后台管理系统</h2>
        <!--   副标题     -->
        <p class="sub-title">前后端分离的后台管理系统架构</p>
        <el-image class="banner-image" :src="loginLeftBanner" />
      </div>
      <el-form
        ref="loginRef"
        :model="loginForm"
        :rules="loginRules"
        class="login-form"
      >
        <h3 class="title">若依后台管理系统</h3>
        <el-form-item prop="tenant">
          <paged-select
            v-model="loginForm.tenant"
            :default-label="defaultTenantNamt"
            :prop="{
              label: 'companyName',
              value: 'tenantId',
            }"
            :query="{
              page: 'pageNum',
              size: 'pageSize',
              searchKey: 'companyName',
            }"
            :remote-method="loadTenantOptions"
            :width="350"
            prefix-icon="OfficeBuilding"
            size="large"
            @change="handleTenantChange"
            @confirm="handleTenantConfirm"
          />
        </el-form-item>
        <el-form-item prop="username">
          <el-input
            v-model="loginForm.username"
            auto-complete="off"
            placeholder="账号"
            size="large"
            type="text"
          >
            <template #prefix>
              <svg-icon class="el-input__icon input-icon" icon-class="user" />
            </template>
          </el-input>
        </el-form-item>
        <el-form-item prop="password">
          <el-input
            v-model="loginForm.password"
            auto-complete="off"
            placeholder="密码"
            size="large"
            type="password"
            @keyup.enter="handleLogin"
          >
            <template #prefix>
              <svg-icon
                class="el-input__icon input-icon"
                icon-class="password"
              />
            </template>
          </el-input>
        </el-form-item>
        <el-form-item v-if="captchaEnabled && loginForm.tenant" prop="code">
          <el-input
            v-model="loginForm.code"
            auto-complete="off"
            placeholder="验证码"
            size="large"
            style="width: 63%"
            @keyup.enter="handleLogin"
          >
            <template #prefix>
              <svg-icon
                class="el-input__icon input-icon"
                icon-class="validCode"
              />
            </template>
          </el-input>
          <div class="login-code">
            <img :src="codeUrl" class="login-code-img" @click="getCode" />
          </div>
        </el-form-item>
        <el-checkbox
          v-model="loginForm.rememberMe"
          style="margin: 0px 0px 25px 0px"
          >记住密码
        </el-checkbox>
        <el-form-item style="width: 100%">
          <el-button
            :loading="loading"
            size="large"
            style="width: 100%"
            type="primary"
            @click.prevent="handleLogin"
          >
            <span v-if="!loading">登 录</span>
            <span v-else>登 录 中...</span>
          </el-button>
          <div v-if="register" style="float: right">
            <router-link :to="'/register'" class="link-type"
              >立即注册
            </router-link>
          </div>
        </el-form-item>
      </el-form>
    </div>

    <!--  底部  -->
    <div class="el-login-footer">
      <span>Copyright © 2018-2023 ruoyi.vip All Rights Reserved.</span>
    </div>
  </div>
</template>

<script setup>
import loginLeftBanner from "@/assets/images/login-left-banner.png";
import { getCodeImg, getTenantNormalList } from "@/api/login";
import Cookies from "js-cookie";
import { decrypt, encrypt } from "@/utils/jsencrypt";
import useUserStore from "@/store/modules/user";
import PagedSelect from "@/components/InfiniteSelect";
import { getCurrentInstance, ref, watchEffect } from "vue";

const userStore = useUserStore();
const router = useRouter();
const { proxy } = getCurrentInstance();

const loginForm = ref({
  tenant: "",
  username: "admin",
  password: "admin123",
  rememberMe: false,
  code: "",
  uuid: "",
});

const loginRules = {
  tenant: [{ required: true, trigger: "change", message: "请选择租户" }],
  username: [{ required: true, trigger: "blur", message: "请输入您的账号" }],
  password: [{ required: true, trigger: "blur", message: "请输入您的密码" }],
  code: [{ required: true, trigger: "change", message: "请输入验证码" }],
};
const defaultTenantNamt = ref("");
const codeUrl = ref("");
const loading = ref(false);
// 验证码开关
const captchaEnabled = ref(true);
// 注册开关
const register = ref(false);
const redirect = ref(undefined);

function handleLogin() {
  proxy.$refs.loginRef.validate((valid) => {
    if (valid) {
      loading.value = true;
      // 勾选了需要记住密码设置在 cookie 中设置记住用户名和密码
      if (loginForm.value.rememberMe) {
        Cookies.set("tenant", loginForm.value.tenant, { expires: 30 });
        Cookies.set("username", loginForm.value.username, { expires: 30 });
        Cookies.set("password", encrypt(loginForm.value.password), {
          expires: 30,
        });
        Cookies.set("rememberMe", loginForm.value.rememberMe, { expires: 30 });
      } else {
        // 否则移除
        Cookies.remove("tenant");
        Cookies.remove("username");
        Cookies.remove("password");
        Cookies.remove("rememberMe");
      }
      // 调用action的登录方法
      userStore
        .login(loginForm.value)
        .then(() => {
          router.push({ path: redirect.value || "/" });
        })
        .catch(() => {
          loading.value = false;
          // 重新获取验证码
          if (captchaEnabled.value) {
            getCode();
          }
        });
    }
  });
}

function getCode() {
  getCodeImg().then((res) => {
    captchaEnabled.value =
      res.captchaEnabled === undefined ? true : res.captchaEnabled;
    register.value = res.register === undefined ? true : res.register;
    if (captchaEnabled.value) {
      codeUrl.value = "data:image/gif;base64," + res.img;
      loginForm.value.uuid = res.uuid;
    }
  });
}

function getCookie() {
  const username = Cookies.get("username");
  const password = Cookies.get("password");
  const rememberMe = Cookies.get("rememberMe");
  loginForm.value = {
    username: username === undefined ? loginForm.value.username : username,
    password:
      password === undefined ? loginForm.value.password : decrypt(password),
    rememberMe: rememberMe === undefined ? false : Boolean(rememberMe),
    tenant: useUserStore().tempTenant ?? "",
  };
}

const loadTenantOptions = (query) =>
  getTenantNormalList(query).then((resp) => resp.rows);

const handleTenantChange = (value) => {
  console.log(value);
  if (!value) {
    useUserStore().setTempTenant({
      tenantId: null,
      companyName: null,
    });
  }
  // useUserStore().setTempTenant(value)
};
const handleTenantConfirm = (option) => {
  useUserStore().setTempTenant(option);
};

watchEffect(() => {
  console.log(loginForm.value.tenant);
  if (loginForm.value.tenant) {
    console.log("getcode");
    getCode();
  }
});
getCookie();
defaultTenantNamt.value = useUserStore().tempTenantName;
</script>

<style lang="scss" scoped>
.login {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url("https://php.likeadmin.cn/admin/assets/login_bg.2f630cea.png");
  //background-image: url("../assets/images/login-background.jpg");
  background-size: cover;
}

.title {
  margin: 0px auto 30px auto;
  text-align: center;
  color: #707070;
}

.login-card {
  border-radius: 14px;
  background: #ffffff;
  display: flex;
  overflow: hidden;
  box-shadow: 0 20px 25px -5px rgb(0 0 0 / 0.1),
    0 8px 10px -6px rgb(0 0 0 / 0.1);

  .login-banner {
    padding: 0 20px 0;
    display: none;
    @media (min-width: 768px) {
      display: inline-block;
    }

    .title,
    .sub-title {
      text-align: center;
      color: #fff;
    }

    .title {
      margin: 32px 0 0;
      font-weight: 900;
    }

    .sub-title {
      margin: 16px 0 0;
      font-weight: 600;
    }

    .banner-image {
      margin-top: 12px;
    }

    width: 400px;
    background-color: #6777fe;
    //background: url("https://php.likeadmin.cn/resource/image/adminapi/default/login_image.png") no-repeat;
    //background-size: cover;
  }

  .login-form {
    width: 400px;
    padding: 25px 25px 5px 25px;

    .el-input {
      height: 40px;

      input {
        height: 40px;
      }
    }

    .input-icon {
      height: 39px;
      width: 14px;
      margin-left: 0;
    }
  }
}

.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}

.login-code {
  width: 33%;
  height: 40px;
  float: right;

  img {
    cursor: pointer;
    vertical-align: middle;
  }
}

.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial, serif;
  font-size: 12px;
  letter-spacing: 1px;
}

.login-code-img {
  height: 40px;
  padding-left: 12px;
}
</style>
